/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.co.newral.workmgr.web.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.actions.DownloadAction.FileStreamInfo;

import jp.co.newral.workmgr.service.bean.UsrBean;
import jp.co.newral.workmgr.service.blogic.MgrAddStaffBLogic;
import jp.co.newral.workmgr.service.blogic.UsrTimeListDownloadBLogic;
import jp.terasoluna.fw.service.thin.BLogicResult;
import jp.terasoluna.fw.web.struts.action.ActionMappingEx;
import jp.terasoluna.fw.web.struts.actions.DownloadBLogicAction;
import jp.terasoluna.fw.web.struts.actions.FileDownloadUtil;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <p>
 *  {NX́A_E[hsꍇBLogic̋NsNXłB<br>
 *  Action璼BLogic̋NsBEJBɂ͑ΉĂȂB
 * </p>
 * <p>
 *  BLogicNXs邽߂ɂ́A
 *  Bean`t@CBLogicActionBean`ŁA
 *  businessLogicvpeBɖړI̋ƖWbNNX
 *  L̗̂悤ɁA&lt;property&gt;vfŎw肷B
 *  킹struts-config.xml̐ݒȉɎB
 * </p>
 * <p>
 * <strong>Bean`t@C̐ݒ</strong>
 * <code><pre>
 * &lt;bean name="/download/downloadAction" scope="prototype"
 *   <strong>class="jp.terasoluna.fw.web.struts.actions.DownloadBLogicAction"</strong>&gt
 *   <strong>&lt;property name="businessLogic"&gt;
 *     &lt;ref bean="downloadBLogic"&gt;&lt;/ref&gt;
 *   &lt;/property&gt;</strong>
 * &lt;/bean&gt
 * &lt;bean id="downloadBLogic" scope="prototype"
 *   <strong>class="jp.terasoluna.sample1.download.blogic.DownloadBLogic"</strong>&gt
 * &lt;/bean&gt
 * </pre></code>
 * </p>
 * <p>
 * <strong>struts-config.xmlBLogicActionݒ</strong>
 * <code><pre>
 *    &lt;action path="/download/downloadAction"
 *       name="_downloadForm"
 *       validate="true"
 *       scope="session"
 *       input="/download/download.jsp"/&gt;
 * </pre></code>
 * </p>
 *
 * @param <P> rWlXWbNւ̓͒lƂȂJavaBeanw肷
 */
public class UsrTimeListDownloadAction extends DownloadBLogicAction<UsrBean> {

    /**
     * ONXB
     */
    Log log = LogFactory.getLog(DownloadBLogicAction.class);
    
    /**
     * srWlXWbNNXB
     */
    private UsrTimeListDownloadBLogic usrTimeListDownloadBLogic = null;

    /**
     * rWlXWbNԋpB
     *
     * @return ێrWlXWbN
     */
    public UsrTimeListDownloadBLogic getUsrTimeListDownloadBLogic() {
        return usrTimeListDownloadBLogic;
    }

    /**
     * rWlXWbNݒ肷B
     *
     * @param mgrAddStaffBLogic rWlXWbN
     */
    public void setusrTimeListDownloadBLogic(UsrTimeListDownloadBLogic usrTimeListDownloadBLogic) {
        this.usrTimeListDownloadBLogic = usrTimeListDownloadBLogic;
    }
    /**
     * BLogicResultWebw̃IuWFNgւ̌ʔfsB
     * <p>
     * ̃NXł<code>resultObject</code>ȉ̏ꍇA
     * _E[hsB
     * <ul>
     * <li>{@link AbstractDownloadObject}pNXłꍇ</li>
     * <li>{@link AbstractDownloadObject}pNXvpeBƂĂPꍇ</li>
     * </ul>
     *
     * @param result BLogicResultCX^X
     * @param request HTTPNGXg
     * @param response HTTPX|X
     * @param mappingEx gANV}bsO
     */
    @Override
    protected void processBLogicResult(
    		BLogicResult result,
            HttpServletRequest request, 
            HttpServletResponse response,
            ActionMappingEx mappingEx){
    	
        super.processBLogicResult(result, request, response, mappingEx);
        if (result.getResultString() != null) {
        	if (log.isWarnEnabled()) {
        		log.warn("result string must not be set. path :" + request.getPathInfo());
        	}
        	result.setResultString(null);
        }

        FileDownloadUtil.download(result.getResultObject(), request, response);
    }
    /**
     * usrTimeListDownloadBLogic̎s
     */   
    public BLogicResult doExecuteBLogic(UsrBean usrBean){
    
    	
    	//BLogicResult result = usrTimeListDownloadBLogic.jxlExecute(usrBean);
    	BLogicResult result = usrTimeListDownloadBLogic.jcomExecute(usrBean);
    	
    	result.setResultString("success");
    	
     	return result;
    	
    
    }
}
